//
// Created by Ari Trachtenberg on 10/9/24.
//

// CHAPTER 8

/**
 * Reads in the contents of a file, and return the (case-insensitive)
 * English-letter frequencies within the file.
 * @param filename The name of the file to read.
 * @return A new array (allocated on the *heap*) whose i-th entry contains
 *    the number of times the i-th letter of the English alphabet appears
 *    within the file, either as a capital or lower-case letter.
 *
 * @example
 * If the file "example.txt" contains the following text:
 * The quick brown fox jumped over the lazy dog.
 *
 * Then labThree_pZero("example.txt") will return a 26-integer
 * array with, among others, the following values:
 * - Its 0th entry will be 1 - because the letter 'a' appears just once in the file.
 * - Its 3rd entry will be 2 - there are two 'd' 's in the file.
 * - It's 14th entry will be 4 - there are four 'o' 's in the file
 */
int *labThree_pZero(string filename);

/**
 * @param filenameCSV A file in CSV (comma-separated values) format,
 *   in which each table row is a line of fields, separated by commas,
 *   following these rules:
 *   - Fields may be enclosed in double quotes, or not.
 *   - Fields *must* be enclosed in quotes if they contain a comma or
 *     double-quote mark.
 *   - Double-quotation marks inside quoted fields are doubled.
 * @return The maximum number of fields in any line of the file.
 *
 * @example 1
 * Suppose the file "example.csv" contains the following, single line:
 * 1729, San Francisco, "Hello, World", "He asked: ""Quo vadis?"""
 *
 * Then labThree_pOne("example.csv") should return 4, corresponding to the
 * four fields:
 * - 1729
 * - San Francisco
 * - Hello, World
 * - He asked: ""Quo vadis?""
 *
 * @example 2
 * Supples the file "example2.csv" contains the following lines:
 * a,b,c
 * "a", "b", "c", "d"
 * 1, 2
 *
 * Then labThree_pOne(example2.csv") should return 4, corresponding to the
 * line with the most fields ("a", "b", "c", "d").
 */
int labThree_pOne(string filenameCSV);

// CHAPTER 9
