//
// Created by Ari Trachtenberg on 10/9/24.
//

// Chapter 9

/**
 * This class represents a student with the following properties:
 * - It has a name (string) and quiz score(s) (int).
 * - It can be constructed with a name, or with a name and a quiz score.
 * - It has an appropriate destructor.
 * - Quiz scores can be added, one at a time, to it with a method addQuizScore.
 * - It has a method getAverageScore() that returns the average
 *      of all scores entered for the student.
 *
 * @example
 * labThree_pTwo student("Jack Daniels");
 * student.addQuizScore(100);
 * student.addQuizScore(70);
 * student.addQuizScore(70);
 * Then student.getAverageScore() should return 80, the average of 100, 70, and 70.
 */
class labThree_pTwo {
    // fill this in here.
};


/**
 * This class represents a person with the following properties:
 * - It has a constructor that creates a person with a given name
 *      (as a string) and no friends.
 * - It has member functions matching the signatures below.
 *
 * @example
 * labThree_pThree person1("Jim");
 * labThree_pThree person2("Jane");
 * labThree_pThree person3("Bob");
 *
 * person1.befriend(person2);
 * person1.befriend(person3);
 * person2.befriend(person1);
 *
 * person1.getFriendCount() - returns 2 (friends)
 * person2.getFriendCount() - returns 1 (friend)
 * person3.getFriendCount() - returns 0
 *
 * person1.getFriends() - returns "Jane, Bob"
 * person2.getFriends() - returns "Jim"
 *
 * person1.getFriendOfFreinds() - returns "Jim"
 * person2.getFriendOfFriends() - returns "Jane, Bob"
 *
 */
class labThree_pThree {

  /**
   * Adds thePerson as a friend of this person.
   * @param thePerson person to add as a friend.
   */
  void befriend(labThree_pThree thePerson);

  /**
   * Removes thePerson as a friend of this person.  If the
   * person was not a friend, then this does nothing.
   * @param thePerson The person to remove.
   */
  void unfriend(labThree_pThree thePerson);

  /**
* @return The number of friends this person has.
*/
  int getFriendCount();

  /**
   * @return A comma-separated list of the names of all friends
   *    of this person, in any order.
   */
  string getFriends();

  /**
   *
   * @return A comma separated list of the names of all friends
   *     of the friends of this person, in any order.
   */
  string getFriendsOfFriends();

};