//
// Created by Ari Trachtenberg on 9/24/24.
//

// CHAPTER 7

/**
 * @param arr an array of at least three double values
 * @param size The size of [arr], which must be >=3
 * @return A pointer to the third largest value of [arr]
 *
 * @example 0
 * int A[] = {1,5,3,2}
 * labTwo_pThree(A,4) returns a pointer to 2 (i.e., A+3) because it is
 * the third largest element in the array.
 *
 * @example 1
 * int B[] = {3,1,4,1,5,9,2,6,5,3,5,6}
 * labTwo_pThree(A,12) returns a pointer to 6 (i.e., either A+7 or A+11).
 */
double* labTwo_pThree(double* arr, int size);


/**
 * @param arr1 An array of characters, terminated with a null character '\0'.
 * @param arr2 Another null-terminated array of characters.
 * @param result An unallocated array of characters.
 *
 * This method concatenates [arr1] and [arr2] into [result]. The array
 * [result] must be sufficiently allocated with "new" to contain the non-null
 * contents of [arr1], [arr2], and a terminating null character.
 */
void labTwo_pFour(const char arr1[], const char arr2[], char*& result);

/**
 * @param src A null-terminated array of characters, representing the source string.
 * @param seek A null-terminated array of characters, representing the pattern to seek.
 * @param replace A null-terminated array of characters, representing the replacement pattern.
 * @return A new null-terminated array of characters that is a copy of [src], but with
 *    each contiguous substring [seek] replaced by [replace].
 *
 * @example 0
 * const char *src0 = "Hatty";
 * const char *seek0 = "t";
 * const char *replace0 = "p";
 * labTwo_pFive(src0, seek0, replace0) returns "Happy", because the "t"'s have been
 * replaced by "p"'s in "Hatty".
 *
 * @example 1
 * const char *src1 = "Hatty";
 * const char *seek1 = "tt";
 * const char *replace1 = "ppil";
 * labTwo_pFive(src1, seek1, replace1) returns "Happily", because the
 * "tt" is replaced with "pp".
 *
 * @example 2
 * const char *src2 = "Happy";
 * const char *seek2 = "p";
 * const char *replace2 = "";
 * labTwo_pFive(src2, seek2, replace2) returns "Hay", because the "p" are each replaced
 * with the empty string "".
 */
char *labTwo_pFive(const char src[], const char seek[], const char replace[]);