//
// Created by Ari Trachtenberg on 9/10/24.
//

// CHAPTER 6

/**
 * @param arr An array of [size] integers
 * @param size The number of integers stored in array [arr]
 * @return The sum of the following for [arr]:
 *    * Every element at even index.
 *    * Every even element.
 *    * The product of the first and last element.
 *
 * @example 1
 * int test[] = {1,2,3};
 * labTwo_pZero(test,3) returns 9 as the sum of:
 *    * 1+3 (elements at even index)
 *    * 2 (even elements)
 *    * 3 (first*last element)
 *
 * @example 2
 * int test2[] = {1,2,3,4};
 * labTwo_pZero(test,4) returns 14 as the sum of:
 *    * 1+3 (elements at even index)
 *    * 2+4 (even elements)
 *    * 4 (first*last element)
 */
int labTwo_pZero(int arr[], int size);


/**
 * @param arr1 An array of [size] integers
 * @param arr2 An array of [size] integers
 * @param size The size of arrays [arr1] and [arr2]
 * @return true iff arr1 and arr2 have the same elements (in any order),
 *    with the same multiplicities (in the case of duplicate elements).
 *
 * @example 1
 * int A1[] = {1,4,9,16,9,7,4,9,11}
 * int A2[] = {11,1,4,9,16,9,7,4,9}
 * labTwo_pOne(A1,A2,9) returns true because both arrays contain the
 *    elements 1, 4 (appears twice), 7, 9 (appears 3 times), 11
 *
 * @example 2
 * int B1[] = {1,4,9,16,9,7,4,9,11}
 * int B2[] = {11,11,7,9,16,4,1,4,9}
 * labTwo_pOne(B1,B2,9) returns false because:
 *    * B1 contains only one 11, and B2 contains 2
 *    * B2 contains 16, which B1 does not
 */
bool labTwo_pOne(int arr1[], int arr2[], int size);


/**
 * @param arr An array of the integers 1 ... size, in some order
 * @param size The size of array [arr], which must also be a perfect square.
 * @return true iff arr, arranged row-by-row into a sqrt(size) x sqrt(size) matrix,
 *    produces a magic square.
 * @see https://en.wikipedia.org/wiki/Magic_square - A magice square is a matrix
 *    each of whose rows, columns, and both diagonals sum to the same value.
 *
 * @example 0
 * int A[] = {1,2,3,5}
 * labTwo_pTwo(A,4) returns false, because A is arranged into the following matrix:
 *    1 2
 *    3 5
 * The sum of the first row is 3, but the sum of the second row is 8.
 * Similarly, the sum of the diagonal from top-left to bottom right is 6, whereas the
 * sum of the contrary diagonal is 5.
 *
 * @example 1
 * int A[] = {2,7,6,9,5,1,4,3,8}
 * labTwo_pTwo(A,9) returns true, because A is arranged into the following matrix:
 *    2 7 6
 *    9 5 1
 *    4 3 8
 *  The sum of any row, column, or diagonal of the matrix equals 15.
 *
 *  @example 2
 *  int B[] = {16,3,2,13,5,10,11,8,9,6,7,12,4,15,14,1}
 *  labTwo_pTwo(A,16) returns true, because A is arranged into the following matrix:
 *     16  3  2 13
 *      5 10 11  8
 *      9  6  7 12
 *      4 15 14  1
 *   The sum of any row, column, or diagonal of the matrix equals 15.
 */
bool labTwo_pTwo(int arr[], int size);